#include <LiquidCrystal.h>


/*Title: Car with remote to choose path
By:Alec, Ben, Dax, Joshua, Noah, Sartak, Sahus*/
// C++ code
//the below allows the user to access the library (ability to use LCD commands because it will recognize said commands) for the LCD

//The below, I found on the sparkfun website
const int rs = 5, en = 4, d4 = 3, d5 = 2, d6 = 10, d7 = 9;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);
//swap motordriver for LCD to avoid serial monitor interacting with
//the LCD (as 0 and 1 can sometimes do that.
//also, the resistor is unneeded for the physical board
//I also found this above on their website
int stateonoff; //checking if it is supposed to be on or off for taking instructions
int button_value; //used to store interger for if the first button is on or off.
int button2_value; //used to store interger for if the second button is on or off.
int button3_value; //used to store interger for if the third button is on or off.
//int turnleft; 
//int turnright; 
//int goforward;
int direction; //used to indicate which direction the robot is supposed to turn in. orientation us left=1 forward=2 right=3. Order based on button order.
int button=A0; //used to establish which analog pin the first button is connected to.
int button2=A1; //used to establish which analog pin the second  button is connected to.
int button3=A2; //used to establish which analog pin the third button is connected to.
int runinstructions;//used when button command is pressed that signals for the robot to run instructions it was given.
int order; //used to establish what the order behind each input is (what the user intended the timeline for the orders to be followed was)
int direction1; //connected to the first order given. The direction they want the robot to move in first.
int direction2; //connected to the second order given. The direction they want the robot to move in second.
int direction3; //connected to the third order given. The direction they want the robot to move in third.
int direction4; //connected to the fourth order given. The direction they want the robot to move in fourth.
int direction5; //connected to the fifth order given. The direction they want the robot to move in fifth.
int direction6; //connected to the sixth order given. The direction they want the robot to move in sixth.
int direction7; //connected to the seventh order given. The direction they want the robot to move in seventh.
int direction8; //connected to the eighth order given. The direction they want the robot to move in eighth.
int direction9; //connected to the ninth order given. The direction they want the robot to move in ninth.
int direction10; //connected to the tenth order given. The direction they want the robot to move in tenth.
int photoresistor=A5;//This is for assigning our photoresistor variable that we use in
//places where the photoresistor is required and we assign
//it to the A5 Analog pin
int photoresistorvalue;//we make this a value as we will probably multiple our result by
//the decimal that converts it to a voltage, which will be this value
int greenleg=6;//This is the leg of the multicolor LED that corresponds to Green LED. It's in the 6 digital pin.
int greenlegvalue;//This is for the value of the Green LED's leg
int redleg=8;//This is the leg of the multicolor LED that corresponds to Red LED. It's in the 8 digital pin.
int redlegvalue;//This is for the value of the Red LED's leg
//the following are for if we desire to add more possible inputs. We do not plan to at this time.
//int direction11;
//int direction12;
//int direction13;
//int direction14;
//int direction15;
//int direction16;
int directionsgiven; //making sure directions given is a variable 
int xdirection; //used for the LCD to determine which way the cursor is supposed to move. This is for the columns.
int ydirection; //also used for the LCD. Determining which row the cursor is supposed to be in.
//Left side for motors
int AIN1 = 7; 
int AIN2 = 0;
int PWMA = 1;
 
//right side for motors
int BIN1 = 11;
int BIN2 = 12;
int PWMB = 13;
//Here, we set the initial conditions for the robot.
int used0;
int used1;
int used2;
int used3;
int used4;
int used5;
int used6;
int used7;
int used8;
int used9;
//Another intial condition.
int lightsup; //only necessary if you want to add the photoresistor addition


//the setup only runs once to set things up
void setup()
{
  //Left side for motors setting state for pins
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(PWMA, OUTPUT);
  
  //right side for the motors. Setting state for pins.
  pinMode(BIN1, OUTPUT);
  pinMode(BIN2, OUTPUT);
  pinMode(PWMB, OUTPUT);
  
  direction=0; //initial condition. The robot starts without a predetermined direction.
  stateonoff=0; //initial condition. The user starts the robot by inputting the correct button command.
  runinstructions=0; //initial conditions. Establishing that the user must input when they want to run instructions. 
  order=0; //Initial conditions. This makes the code start at the first possible order. 
  xdirection=0; //initial conditions. We want the cursor to start in the first column. 
  ydirection=0; //initial conditions. We want the cursor to start in the first row. 
  directionsgiven=0; //initial conditions. We want it so the order doesn't starting going up before commands start!
  used0=0;
  used1=0;
  used2=0;
  used3=0;
  used4=0;
  used5=0;
  used6=0;
  used7=0;
  used8=0;
  used9=0;
  lightsup=0;
  lcd.begin(16, 2);//setting the LCD for its 2 rows and 16 columns
  //Below,we print a message to the LCD.
  lcd.print("Test");
  //a half second delay for the test to show
  delay(500);
  //then below we clear the test
  lcd.clear();
  //then we begin the serial monitor at the 9600 baud rate
  //Serial.begin(9600);
}
//the loop runs continuously after it is started
void loop() {
  //set the cursor to column 0, line 1
  //(note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(0, 1);
  /*
  Possible Addition: Photoresistor:
  
  photoresistorvalue=analogRead(photoresistor)*0.004882813;//we are reading the pin for the photoresistor
  //and we are multiplying the result by a constant that makes it equivalent to a voltage.
  //as this part of the robot is not strictly necessary
  //I included this bit of code as a function that you can either include or not
  //it
  
if (lightsup=1)//I decided to make it stay in this mode once lowlight was detected even once
{//so it reads if it was ever detected then runs this inside
  //Just turning the red LED to full bright
  analogWrite(redleg,255);
  delay(3000);//this is a long pause because I want to make sure they know
  analogWrite(redleg,0);//then turn off the LED
}
*/
  //I read all three buttons checking what was pressed
   button_value=digitalRead(button);
    button2_value=digitalRead(button2);
    button3_value=digitalRead(button3);
  //check if all three buttons are pressed at once.
   if (button_value==HIGH && button2_value==LOW && button3_value==HIGH){
    //toggles the state for taking directions
    stateonoff=1;
    //turnleft=0;
    //turnright=0;
    //goforward=0;
    //serial monitor is used to check whether or not signals are going through properly
    Serial.println("TURN ON.");
    //I then do a sequence of redlight, greenlight, then a mix for a couple of seconds 
    //to let them know it's on
    analogWrite(redleg,255); 
    delay(500);
    analogWrite(redleg,0);
    delay(500);
    analogWrite(greenleg,255); 
    delay(500);
    analogWrite(greenleg,0);
    delay(500);
    analogWrite(redleg,200);
    analogWrite(greenleg,200);
    delay(500);
    analogWrite(redleg,0);
    analogWrite(greenleg,0);
    delay(500);
     lcd.setCursor(0,0);
     lcd.print("Turning on");
     delay(1000);
     lcd.clear();
  }
  //stateonoff=1;
  //if it is indicated it is supposed to be in the state of directions the if statement will run
  if (stateonoff==1){
    //check if buttons were pressed to command turning left
    if (button_value==HIGH && button2_value==LOW && button3_value==LOW){
      //consider an LED flashing on and off after serial print and before it
      //We just chose to put LEFT in the serial monitor first
      Serial.println("LEFT.");
      //then set the direction and then that directions were given
      direction=1;
      directionsgiven=1;
      //and then the green light for a second
      analogWrite(greenleg,255); 
      delay(1000);
      analogWrite(greenleg,0); 
    }
    delay(200);// short delay 
    //the following three if statements may appear redundant, but it simplifies memorization
    //for the user. If you press any two buttons simultaneously, the commands you inputted will run as given.
    //check if buttons were pressed to command run
    if (button_value==HIGH && button2_value==LOW && button3_value==HIGH){
      //in this case, we first put that we ran the turning off command into the serial monitor 
      Serial.println("TURN OFF.");
      lcd.clear(); //then we clear whatever was on the LCD
      lcd.setCursor(0,0); //then we set the cursor to thr bottom right corner
      lcd.print("Turning off"); //then we display "turning off"
      delay(1500); //I think one and a half seconds in long enough
      //to wait before we really start turning it off so the user can see
      stateonoff=0; //we then make it so the if statement corresponding to the robot taking commands being off, so
      //no stateonoff=1 anymore
      //then, below, we run the same LED sequence as when we turn the robot on
      //it makes it 
      analogWrite(redleg,255); //we first hve the red light on all the way
      delay(500);//leave it on for half a second
      analogWrite(redleg,0);//then turn it off
      delay(500); //leave LED off for half a sec
      analogWrite(greenleg,255);//then turn the green on for half a sec 
      delay(500);
      analogWrite(greenleg,0); //then its off
      delay(500);
      analogWrite(redleg,200);//then we turn both on for half a second then turn both off again
      analogWrite(greenleg,200);
      delay(500);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      delay(500);
      lcd.clear();//we then clear the message that explained we were turning off the robot
    }
    delay(200);
    //again, checking for running
    /*if (button_value==HIGH && button2_value==HIGH && button3_value==LOW){
      Serial.println("RUN.");
      runinstructions=1;
      stateonoff==0;
      analogWrite(redleg,200);
      analogWrite(greenleg,200);
      delay(500);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      delay(500);
    }*/
    delay(200);
    //the last command to check if the bot is meant to run
    if (button_value==LOW && button2_value==HIGH && button3_value==HIGH){
      Serial.println("RUN.");
      runinstructions=1;
      stateonoff==0;
      analogWrite(redleg,200);
      analogWrite(greenleg,200);
      delay(500);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      delay(500);
    }
    delay(200);
    //check if buttons were pressed in the forward command orientation
    if (button2_value==HIGH && button_value==LOW && button3_value==LOW){
      Serial.println("FORWARD.");
      direction=2;
      directionsgiven=1;
      analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
    }
    delay(200);
    //check if buttons were pressed in the right command orientation
    if (button3_value==HIGH && button2_value==LOW && button_value==LOW){
      Serial.println("RIGHT.");
      direction=3;
      directionsgiven=1;
      analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
    }
    delay(5000);
    //this one isn't working, but if you can make it work, go for it.
    //if the user wants to stop being able to input commands/run the robot, they can turn those functions off by pressing the buttons simultaneously again
    /*if(button==HIGH && button2==HIGH && button3==HIGH){
      //in this case, we first put that we ran the turning off command into the serial monitor 
      Serial.println("TURN OFF.");
      lcd.clear(); //then we clear whatever was on the LCD
      lcd.setCursor(0,0); //then we set the cursor to thr bottom right corner
      lcd.print("Turning off"); //then we display "turning off"
      delay(1500); //I think one and a half seconds in long enough
      //to wait before we really start turning it off so the user can see
      stateonoff=0; //we then make it so the if statement corresponding to the robot taking commands being off, so
      //no stateonoff=1 anymore
      //then, below, we run the same LED sequence as when we turn the robot on
      //it makes it 
      analogWrite(redleg,255); //we first hve the red light on all the way
      delay(500);//leave it on for half a second
      analogWrite(redleg,0);//then turn it off
      delay(500); //leave LED off for half a sec
      analogWrite(greenleg,255);//then turn the green on for half a sec 
      delay(500);
      analogWrite(greenleg,0); //then its off
      delay(500);
      analogWrite(redleg,200);//then we turn both on for half a second then turn both off again
      analogWrite(greenleg,200);
      delay(500);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      delay(500);
      lcd.clear();//we then clear the message that explained we were turning off the robot
    }*/
    delay(200);
    //this is for the first order and checks whether or not we are on the first order in the loop  
    //if you want to use cases, try the following
/*
    if (order==0 && used0==0){ 

      //if we are (we have to be to get in here), then it will check which direction you inputted 

      //if they nothing left, this will be set as the first command. 

      used0=1; 

      //I just wanted to demonstrate using a switch command 

      switch (direction) { //a switch, so it can have different responses depending on what response it received. 

    case 0: //when the nothing is pressed (that's the corresponding meaning) 

      used0=0; 

      order=0; 

          directionsgiven=0; 

      Serial.println("NO DIRECTION CHOSEN"); 

      break; //otherwise, the cases below will also run 

    case 1: //if they chose left, this will be set as the first command.      direction1=1; 

          xdirection=xdirection+1; 

      ydirection=ydirection+0; 

          lcd.setCursor(xdirection, ydirection); 

          lcd.print("1"); 

          Serial.println("First Direction Set as Left"); 

          directionsgiven=0; 

            order=1; 

          analogWrite(greenleg,255);  

          delay(1000); 

          analogWrite(greenleg,0); 

      break; //otherwise, the cases below will also run 

    case 2://if they chose forward, this will be set as the first command. 

      direction1=2; 

          xdirection=xdirection+0; 

      ydirection=ydirection+1; 

          lcd.setCursor(xdirection, ydirection); 

          lcd.print("1"); 

          Serial.println("First Direction Set as Forward"); 

          directionsgiven=0;  

          order=1; 

      break; //otherwise, the cases below will also run 

        case 3://if they chose right, this will be set as the first command. 

        used0=0; 

    order=0; 

        directionsgiven=0; 

        Serial.println("Please choose a different input"); 

        lcd.print("ERROR: OOB"); //OOB: out of bounds 

        //I decided to include an error sequence here. 

        analogWrite(redleg,255);  

        delay(500); 

        analogWrite(redleg,0); 

        delay(500); 

        analogWrite(redleg,255);  

        delay(500); 

        analogWrite(redleg,0); 

        delay(500); 

        analogWrite(redleg,255);  

        delay(500); 

        analogWrite(redleg,0); 

    } 

    direction=0; 

    } 

    //as order increases when the previous order is filled, the code 

    //progressively sets directions according to button inputs. 

    //I'll write comments for the first three orders because they will be the same as the rest of the code 

    //I will highlight the differences in each collection in the first three orders 

    //though the differences are small and are relatively easy to pick up on, hopefully. 
    */
    if (order==0 && used0==0){
        used0=1;
      if (direction==1){
        direction1=1;
        
        ydirection=ydirection-1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("1");
        Serial.println("First Direction Set as Left");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction1=2;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("1");
        directionsgiven=0;
        
        order=order+1;
		Serial.println("First Direction Set as Forward");
        analogWrite(redleg,255); 
     
      	delay(1000);
      	analogWrite(redleg,0); 
      }
      if (direction==3){
        direction1=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("1");
        Serial.println("First Direction Set as Right");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
        /*
        This constitutes a place with the first possible error.
        Optional Failsafe:
        if (ydirection==2) {
          ydirection=0;
          Serial.println("PLEASE TURN OFF THE ROBOT AND TURN IT BACK ON AGAIN");
          Serial.println("IMPROPER INPUT OUT OF BOUNDS!");
          Serial.println("ROBOT IN ERROR STATE");
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("RESETING ROBOT");
          stateonoff=0;
        }
        else{
        lcd.setCursor(xdirection, ydirection);
        lcd.print("1");
        Serial.println("First Direction Set as Right");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
        }
        */
      }
        if (direction==0){
        used0=0;
		order=0;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==1 && used1==0){
        used1=1;
      if (direction==1){
        direction2=1;
        
        ydirection=ydirection-1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("2");
        Serial.println("Second Direction Set as Left");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
        /*
        Optional Failsafe:
        if (ydirection==-2) {
          ydirection=0;
          Serial.println("PLEASE TURN OFF THE ROBOT AND TURN IT BACK ON AGAIN");
          Serial.println("IMPROPER INPUT OUT OF BOUNDS!");
          Serial.println("ROBOT IN ERROR STATE");
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("RESETING ROBOT");
          stateonoff=0;
        }
        else{
        lcd.setCursor(xdirection, ydirection);
        lcd.print("2");
        Serial.println("First Direction Set as LEFT");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
        }
        We assume you will not need the failsafe because you know how it works.
        If other people are using the robot, consider implementing the fail safe in
        each and every line using this format. It is not necessary in the first loop to have both failsafes.
        
        */
      }
      if (direction==2){
        direction2=2;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("2");
        directionsgiven=0;
        
        order=order+1;
		Serial.println("Second Direction Set as Forward");
        analogWrite(redleg,255); 
     
      	delay(1000);
      	analogWrite(redleg,0); 
        
      }
      if (direction==3){
        direction2=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("2");
        Serial.println("Second Direction Set as Right");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
        /*
        Optional Failsafe:
        if (ydirection==2) {
          ydirection=0;
          Serial.println("PLEASE TURN OFF THE ROBOT AND TURN IT BACK ON AGAIN");
          Serial.println("IMPROPER INPUT OUT OF BOUNDS!");
          Serial.println("ROBOT IN ERROR STATE");
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("RESETING ROBOT");
          stateonoff=0;
        }
        else{
        lcd.setCursor(xdirection, ydirection);
        lcd.print("2");
        Serial.println("Second Direction Set as RIGHT");
        directionsgiven=0;
        
        order=order+1;
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
        }
        */
      }
        if (direction==0){
        used1=0;
		order=1;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==2 && used2==0){
        used2=1;
      if (direction==1){
        direction3=1;
        
        ydirection=ydirection-1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("3");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Third Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction3=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("3");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Third Direction Set as Forward");
        analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
      }
      if (direction==3){
        direction3=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("3");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Third Direction Set as Right");
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      }
        if (direction==0){
        used2=0;
		order=2;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==3 && used3==0){
      if (direction==1){
        direction4=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("4");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Fourth Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction4=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("4");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Fourth Direction Set as Forward");
        analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
      }
      if (direction==3){
        direction4=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("4");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Fourth Direction Set as Right");
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      }
        if (direction==0){
        used3=0;
		order=3;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==4 && used4==0){
      if (direction==1){
        direction5=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("5");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Fifth Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction5=2;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("5");
        directionsgiven=0;
        
        order=order+1;
		Serial.println("Fifth Direction Set as Forward");
        analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
      }
      if (direction==3){
        direction5=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("5");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Fifth Direction Set as Right");
        analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
      }
        if (direction==0){
        used4=0;
		order=4;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==5 && used5==0){
      if (direction==1){
        direction6=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("6");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Sixth Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction6=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("6");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Sixth Direction Set as Forward");
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
      }
      if (direction==3){
        direction6=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("6");
        directionsgiven=0;
        analogWrite(redleg,255); 
     	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
        
        order=order+1;
        Serial.println("Sixth Direction Set as Right");
      }
        if (direction==0){
        used5=0;
		order=5;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==6 && used6==0){
      if (direction==1){
        direction7=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("7");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Seventh Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction7=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("7");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Seventh Direction Set as Forward");
        analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
      }
      if (direction==3){
        direction7=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("7");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Seventh Direction Set as Right");
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      }
        if (direction==0){
        used6=0;
		order=6;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==7 && used7==0){
      if (direction==1){
        direction8=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("8");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Eighth Direction Set as Left");
      }
      if (direction==2){
        direction8=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("8");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Eighth Direction Set as Forward");
        analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
      }
      if (direction==3){
        direction8=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("8");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Eighth Direction Set as Right");
        analogWrite(redleg,255); 
      analogWrite(greenleg,20); 
      delay(1000);
      analogWrite(redleg,0);
      analogWrite(greenleg,0);
      }
        if (direction==0){
        used7=0;
		order=7;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==8 && used8==0){
      if (direction==1){
        direction9=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("9");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Ninth Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction9=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("9");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Ninth Direction Set as Forward");
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
      }
      if (direction==3){
        direction9=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("9");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Ninth Direction Set as Right");
        analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
      }
        if (direction==0){
        used8=0;
		order=8;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
      if (order==9 && used9==0){
      if (direction==1){
        direction10=1;
        
        ydirection=ydirection+1;
		xdirection=xdirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("10");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Tenth Direction Set as Left");
        analogWrite(greenleg,255); 
      	delay(1000);
      	analogWrite(greenleg,0);
      }
      if (direction==2){
        direction10=2;
        
        xdirection=xdirection+1;
		ydirection=ydirection+0;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("10");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Tenth Direction Set as Forward");
        analogWrite(redleg,255); 
      	delay(1000);
      	analogWrite(redleg,0); 
      }
      if (direction==3){
        direction10=3;
        
        xdirection=xdirection+0;
		ydirection=ydirection+1;
        lcd.setCursor(xdirection, ydirection);
        lcd.print("10");
        directionsgiven=0;
        
        order=order+1;
        Serial.println("Tenth Direction Set as Right");
        analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
      }
        if (direction==0){
        used9=0;
		order=9;
        directionsgiven=0;
		Serial.println("NO NEW DIRECTION CHOSEN");
		}
        direction=0;
    }
    
  }
  delay(10); //Just delaying 1 milisecond
  //for testing of the motors, use the below.
  /*runinstructions=1;
  direction1=1;
  direction2=2;
  direction3=3;
  direction4=3;
  direction5=2;*/
  //the below runs when we hit the button configuration for run and it sets
  //runinstrictions to 1
  //I plan to only write comments for direction1
  //direction2 and direction3 because I want to highlight the few
  //differences between the commands, and they are very few.
  if(runinstructions==1){
  if (direction1==1){//for left command
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction1==2){//for straight command
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
  }
    //The reason I left a right command here even when it won't be
    //displayed on the LCD
    //is in case someone wanted to allow this, for  whatever reason.
  if (direction1==3){//for left command
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction2==1){ //for forward command
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
    
  }
  if (direction2==2){ //for right command
    //Left side for motors
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
  }
  if (direction2==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
  }
  if (direction3==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction3==2){
    //Left side for motors
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
  }
  if (direction3==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
  }
  if (direction4==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction4==2){
    //Left side for motors
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 255);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0); 
  }
  if (direction4==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction5==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction5==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction5==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction6==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction6==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction6==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction7==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction7==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction7==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction8==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction8==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction8==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction9==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction9==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction9==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
  if (direction10==1){
    //Left side for motors
    //with ain1 and ain2, I will more explain what changing LOW and HIGH does
    //rather than the commands themselves
    
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    //also for bin1 and bin2 I will explain more what LOW and HIGH
    //does rather than the full lines.
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(greenleg,255); 
    delay(1000);
    analogWrite(greenleg,0);
  }
  if (direction10==2){
    //Left side for motors
   digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    analogWrite(redleg,255); 
      delay(1000);
      analogWrite(redleg,0);
  }
  if (direction10==3){
    //Left side for motors
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200); 
    delay(1000);
    delay(100);
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 200);
    //Right side for motors
    digitalWrite(BIN1, LOW);
    digitalWrite(BIN2, HIGH);
    analogWrite(PWMB, 200);
    delay(1000);
    delay(100);
    analogWrite(redleg,255); 
      	analogWrite(greenleg,20); 
      	delay(1000);
      	analogWrite(redleg,0);
      	analogWrite(greenleg,0);
  }
    runinstructions=0; //yeah, I also do this below, just in case.
    /*digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, HIGH);
    analogWrite(PWMA, 0);
    //Right side for motors
    digitalWrite(BIN1, HIGH);
    digitalWrite(BIN2, LOW);
    analogWrite(PWMB, 0);*/
  }
  if (runinstructions==1) {// once all directions are run, we will run this sequence
  lcd.clear();//we clear the LCD
  lcd.print("Commands run!"); //we notify the user through the LCD
  Serial.println("All commands have been run");//and the serial monitor, if they are using it
  //Below, I decided to have it run the light sequence it runs when it finishes its path
  analogWrite(redleg,200);// we then do the same color we did before for running the code, and for the same amount of time
  analogWrite(greenleg,200);
  delay(500);
  analogWrite(redleg,0);
  analogWrite(greenleg,0);
  delay(500);
    //we then set the run instructions to zero 
  runinstructions=0; //I could, instead, put this below, but runinstructions will only
    //equal one when the button configuration is pressed.
    //then we get ready for the robot to be reset:
    //stateonoff=0; I actually realize we already did this once we activated the run command
  }
  if (stateonoff==0) //if we are turning off the robot, we want it to reset for the next time it is used
  {
    //here, we set the proper initial conditions to act like no directions have 
    //already been chosen
  used0=0;//these used commands are used after the first, in this case, button press
  used1=0;//this is when the second button is pressed
  used2=0;//etc.
  used3=0;
  used4=0;
  used5=0;
  used6=0;
  used7=0;
  used8=0;
  used9=0;
  order=0;
  direction1=0;//setting the first direction to undetermined
  direction2=0;//the second direction to undetermined
  direction3=0;//etc.
  direction4=0;
  direction5=0;
  direction6=0;
  direction7=0;
  direction8=0;
  direction9=0;
  direction10=0;
}
}
